function [b,stdb,pseudoR]=MA2SLS_Core(y,X,Z,W,d1)

n =size(y,1);
M =size(Z,2);
if size(W,1)<M
   W = [W;zeros(M-size(W,1),1)];
end
PW = zeros(n,n);
for j = 1:M
    Z1 = Z(:,1:j);
    PW = PW+W(j)*((Z1/(Z1'*Z1))*Z1');
end
b = (X'*PW*X)\(X'*PW*y);
u = y-X*b;
Xu = ((X'*PW)').*(u*ones(1,size(X,2)));
V = Xu'*Xu/n;
stdb = sqrt(diag(((X'*PW*X/n)\V)/(X'*PW*X/n)/n));
if (size(X,2)-d1)==1
   X = X(:,end);
   pseudoR = (X'*PW*X)^2/((X'*PW*PW*X)*(X'*X));
else
   pseudoR = [];
end
end