function [b,stdb]=MALIML_Core(y,X,Z,W)

n =size(y,1);
M =size(Z,2);
V =[y X];
if size(W,1)<M
   W = [W;zeros(M-size(W,1),1)];
end
PW   = zeros(n,n);
Lam  = 0;
for j = 1:M
    Z1  = Z(:,1:j);
    Pm  = (Z1/(Z1'*Z1)*Z1');
    H   = (V'*Pm*V)/(V'*V);
    Lam = Lam+W(j)*min(eig((H+H')/2));
    PW  = PW+W(j)*Pm;
end
b    = (X'*PW*X-Lam*(X'*X))\(X'*PW*y-Lam*X'*y);
u    = y-X*b;
Xu   = ((X'*PW-Lam*X')').*(u*ones(1,size(X,2)));
V    = Xu'*Xu/n;
stdb = sqrt(diag((((X'*PW*X-Lam*(X'*X))/n)\V)/((X'*PW*X-Lam*(X'*X))/n)/n));
end