function [W,exit]=SWLIML(W,se,sl,sle,U,N,type,con)

W0  = W;
M = size(W,1);
K = (1:M)';
G = zeros(M);
for i = 1:M;
    G = G + [zeros(i-1,M);[zeros(M-i+1,i-1) (ones(M-i+1,1)*ones(1,M-i+1))]];
end

H   = 2*((se*sl-sle^2)*G+se*(U-sl*G))/N;
H   = (H+H')/2;
f   = (-se*sl*(ones(M,1)*M-2*K))/N;
switch type
    case 'U'       
      %options         = optimset('LargeScale','off');  
      [W,fval,exit]   = quadprog(H,f,[],[],ones(M,1)',1,[],[],W0);
    case 'C'
      options         = optimset('LargeScale','off');
      [W,fval,exit]   = quadprog(H,f,[],[],ones(M,1)',1,-ones(M,1),ones(M,1),W0,options);  
    case 'P'
      options         = optimset('LargeScale','off');
      if con
         Aeq = [ones(1,M);[1 zeros(1,M-1)]];
         beq = [1;0];
         [W,fval,exit]   = quadprog(H,f,[],[],Aeq,beq,zeros(M,1),ones(M,1),W0,options);  
      else
          options         = optimset('LargeScale','off');
          [W,fval,exit]   = quadprog(H,f,[],[],ones(M,1)',1,zeros(M,1),ones(M,1),W0,options);
      end
end

end
        
