function  [W,exit] = SWTSLS(W,a,b,B,se,sl,U,N,type,d1)

W0  = W;
M = size(W,1);
K = (1:M)';
G = zeros(M);
for i = 1:M;
    G = G + [zeros(i-1,M);[zeros(M-i+1,i-1) (ones(M-i+1,1)*ones(1,M-i+1))]];
end

H   = 2*(a*(K*K')+b*G+se*(U-sl*G))/N;
H   = (H+H')/2;
f   = (-B*K-se*sl*(ones(M,1)*M-2*K))/N;
switch type
    case 'U'       
         Aeq          = [ones(1,M) ;[eye(d1) zeros(d1,M-d1)]];
         beq          = [1;zeros(d1,1)];
         [W,fval,exit]   = quadprog(H,f,[],[],Aeq,beq,[],[],W);
    case 'C'
         options         = optimset('LargeScale','off');
         Aeq          = [ones(1,M);[eye(d1) zeros(d1,M-d1)]];
         beq          = [1;zeros(d1,1)];
         [W,fval,exit]   = quadprog(H,f,[],[],Aeq,beq,-ones(M,1),ones(M,1),W0,options);  
    case 'P'
         options         = optimset('LargeScale','off');
         Aeq          = [ones(1,M);[eye(d1) zeros(d1,M-d1)]];
         beq          = [1;zeros(d1,1)];
         [W,fval,exit] = quadprog(H,f,[],[],Aeq,beq,zeros(M,1),ones(M,1),W0,options);  
end

end
        
