function [b]=Fuller(y,X,Z,alpha)

N   = size(y,1);
M   = size(Z,2);
V   = [y,X];
PW  = (Z*inv(Z'*Z)*Z');
Lam = min(eig((V'*PW*V)*inv(V'*V)));
Lam = (Lam-alpha/(N-M)*(1-Lam))/(1-alpha/(N-M)*(1-Lam));
b   = inv(X'*PW*X-Lam*X'*X)*(X'*PW*y-Lam*X'*y);
end