function [W,s]=SWTSLSsq(W,a,se,sl,U,N,d)

M = size(W,1);
K = (1:M)';
G = zeros(M);
for i = 1:M;
    G = G + [zeros(i-1,M);[zeros(M-i+1,i-1) (ones(M-i+1,1)*ones(1,M-i+1))]];
end
s = Inf;
m = 0;
for i=d:M
    W    = zeros(M,1);
    W(i) = 1;
    KW   = K'*W;
    WGW  = W'*G*W;
    sNew    = (a*KW^2)/N+se*(W'*U*W-sl*(-2*KW+WGW))/N;
    if sNew<s
       s = sNew;
       m = i;
    end
end
W    = zeros(M,1);
W(m) = 1;
end
        
